//+------------------------------------------------------------------+
//|                                        DonOmar_Zup_upgrade_1.mq4 |
//|                                                              Oxy |
//|                                   http://oxy.opentraders.ru/bio/ |
//+------------------------------------------------------------------+
#property copyright "Oxy"
#property link      "http://oxy.opentraders.ru/bio/"
#property version   "1.00"
#property strict
//-------    -----------------------------------------+
extern double              Lot               = 0.1;         // 
extern double              K_Lot             = 2;           //     , 1 -  
extern int                 TakeProfit        = 700;         //    , 0 -  
extern int                 StopLoss          = 500;         //    , 0 -  
extern int                 InpKPeriod        = 5;           // Stochastic - K Period
extern int                 InpDPeriod        = 3;           // Stochastic - D Period
extern int                 InpSlowing        = 3;           // Stochastic - Slowing
extern int                 RSI_period        = 5;           // RSI - 
extern ENUM_APPLIED_PRICE  RSI_applied_price = PRICE_CLOSE; // RSI -  
extern int                 RSI_Level_buy     = 30;          // RSI -  buy
extern int                 RSI_Level_sell    = 70;          // RSI -  sell
extern int                 CCI_period        = 5;           // CCI - 
extern ENUM_APPLIED_PRICE  CCI_applied_price = PRICE_CLOSE; // CCI -  
extern int                 CCI_Level_buy     = -100;        // CCI -  buy
extern int                 CCI_Level_sell    = 100;         // CCI -  sell
              
extern int            Slippage               = 30;          //  
extern int            MagicNumber            = 5675931;     //  
extern string         AboutTrail             = "_____________________________";  //  
extern int            PlusPoints_breakeven   = 200;         //   ,    SL  , 0 -  
extern int            StepSL_plus_breakeven  = 50;          //  , 0 -  
extern int            PlusPoints_trail       = 200;         //   ,    SL, 0 -  
extern int            StepSL_plus_trail      = 50;          //  , 0 -  
//-------    -------------------------------------+
string   Symb;
string   NameInd_St = "Stochastic";
string   NameRect   = "_3PointD_1";
string   BUY        = "BUY";
string   SELL       = "SELL";
int      LastTicket = -1;
datetime LastTime   = -1;
double   newLot     = Lot;
double   MINLOT;
double   MAXLOT;
double   minStopLevel;
bool     StopExp    = false;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if (!IsTradeAllowed()) { Print("   "); return(INIT_FAILED);}
   Symb = Symbol();
   MINLOT = MarketInfo(Symb, MODE_MINLOT);
   MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
   if (Lot<MINLOT || Lot>MAXLOT) { Print("  !"); return(INIT_FAILED);}  
   if (K_Lot<=0) K_Lot=1;
   if (TakeProfit!=0 && TakeProfit<MarketInfo(Symb, MODE_STOPLEVEL)) {Print("  Take Profit"); return(INIT_FAILED);}
   if (StopLoss!=0   && StopLoss  <MarketInfo(Symb, MODE_STOPLEVEL)) {Print("  Stop Loss");   return(INIT_FAILED);}   
   minStopLevel = MarketInfo(Symb, MODE_STOPLEVEL);
   if(StepSL_plus_breakeven!= 0 && PlusPoints_breakeven!=0 && PlusPoints_breakeven-minStopLevel<=StepSL_plus_breakeven) { Print("   !"); return(INIT_FAILED);}
   if(StepSL_plus_trail!= 0     && PlusPoints_trail!=0     && PlusPoints_trail    -minStopLevel<=StepSL_plus_trail    ) { Print("   !");     return(INIT_FAILED);}
   LastTime = Time[0];
   newLot   = Lot;
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) { Comment(""); }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
    if (StopExp) return;
    if(HaveOpenPos()==false) {
      double _main_blue = iCustom (Symb, 0, NameInd_St, InpKPeriod, InpDPeriod, InpSlowing, 0, 0);
      double _sign_red  = iCustom (Symb, 0, NameInd_St, InpKPeriod, InpDPeriod, InpSlowing, 1, 0);
      string   trendOrd ="";;
      if(_main_blue<20 && _main_blue>_sign_red) trendOrd = BUY;
      if(_main_blue>80 && _main_blue<_sign_red) trendOrd = SELL;
      //  
      if(trendOrd!="" && ObjectFind(NameRect) == 0) {
        datetime time1 = (datetime)ObjectGet(NameRect, OBJPROP_TIME1);
        datetime time2 = (datetime)ObjectGet(NameRect, OBJPROP_TIME2);
        if(time1<=Time[0] && time2>=Time[0]) {
          double price1 = (double) ObjectGet(NameRect, OBJPROP_PRICE1);
          double price2 = (double) ObjectGet(NameRect, OBJPROP_PRICE2);
          double priceUp = price1; double priceDn = price2;
          if(priceDn>priceUp){ priceUp = price2; priceDn = price1; }
          int _lastPos; double _newLot;
          
          double _iRSI = iRSI(Symb, NULL, RSI_period, RSI_applied_price, 0);
          double _iCCI = iCCI(Symb, NULL, CCI_period, CCI_applied_price, 0);
          
          if(trendOrd == BUY) {
            if(Ask<=priceUp && Ask>=priceDn && _iRSI<RSI_Level_buy && _iCCI<CCI_Level_buy) {
              _lastPos = isClosePosByProfit_or_Loss();              
              if(_lastPos==0) _newLot = K_Lot*newLot; else _newLot = Lot;
              newLot = CheckLot (_newLot);
              if(newLot==-1) {
                Print  ("  !  !");
                Comment("  !  !");
                StopExp = true;
                return;
              }
              BuyPos_stepPoint (newLot, StopLoss, TakeProfit);
            }
          } else {
            if(Bid<=priceUp && Bid>=priceDn && _iRSI>RSI_Level_sell && _iCCI>CCI_Level_sell) {
              _lastPos = isClosePosByProfit_or_Loss();              
              if(_lastPos==0) _newLot = K_Lot*newLot; else _newLot = Lot;
              newLot = CheckLot (_newLot);
              if(newLot==-1) {
                Print  ("  !  !");
                Comment("  !  !");
                StopExp = true;
                return;
              }
              SellPos_stepPoint(newLot, StopLoss, TakeProfit);
            }
          }
        }
      }
    } else { 
      //________________________________________________________________
      //    
      if(StepSL_plus_breakeven>0 && PlusPoints_breakeven>0) {
        changeBreakevenTrailPos();
      } 
    }
  }
//+------------------------------------------------------------------+
void changeBreakevenTrailPos () {
  int i;
  double sl, opPr;
  double _plusPoints, _stepSL;
  for (i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {      
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        opPr = OrderOpenPrice();
        
        if(OrderType()==0){ // BUY
          sl = OrderStopLoss();
          if(sl<=opPr) { sl=opPr; _plusPoints=PlusPoints_breakeven; _stepSL=StepSL_plus_breakeven;}
          else         {          _plusPoints=PlusPoints_trail;     _stepSL=StepSL_plus_trail;    }
          if(_plusPoints<=0 || _stepSL<=0) continue;
          //  SL   
          if(Ask-_plusPoints*Point>=sl) {
            sl=sl+_stepSL*Point;
            if(!OrderModify(OrderTicket(), opPr,  NormalizeDouble(sl,Digits),  OrderTakeProfit(), 0))
              Print("    ", OrderTicket());
          }
        }
        if(OrderType()==1) { // SELL
          sl = OrderStopLoss();
          if(sl==0 || sl>=opPr) { sl=opPr; _plusPoints=PlusPoints_breakeven; _stepSL=StepSL_plus_breakeven;}
          else                  {          _plusPoints=PlusPoints_trail;     _stepSL=StepSL_plus_trail;    }
          if(_plusPoints<=0 || _stepSL<=0) continue;
          //  SL   
          if(Bid+_plusPoints*Point<=sl) {
            sl=sl-_stepSL*Point;
            if(!OrderModify(OrderTicket(), opPr,  NormalizeDouble(sl,Digits),  OrderTakeProfit(), 0))
              Print("    ", OrderTicket());
          }
        }
      }
    }
  }
}
//+------------------------------------------------------------------+
double CheckLot (double someLot) {
  if(someLot<MINLOT) someLot=MINLOT;
  if(someLot>MAXLOT) someLot=MAXLOT;  
  if(MarketInfo(Symb, MODE_MARGINREQUIRED)*someLot >= AccountFreeMargin()) someLot=-1;
  return (someLot);
}
//+------------------------------------------------------------------+
int isClosePosByProfit_or_Loss() {
  //    = 1,   = 0,    = -1
  int i, k=OrdersHistoryTotal();
  
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        if(OrderCloseTime()>LastTime && OrderTicket()!=LastTicket) {
          double opPr = OrderOpenPrice();
          LastTime    = OrderCloseTime();
          LastTicket  = OrderTicket();
          if(OrderType () == 0) {
            if(OrderClosePrice() >= opPr) return(1); //   
            else                          return(0); //   
          }
          if(OrderType() == 1) {
            if(OrderClosePrice() <= opPr) return(1); //   
            else                          return(0); //   
          }          
        }
      }
    }
  }
  return(-1);
}
//+------------------------------------------------------------------+
bool HaveOpenPos(int ot=-1) {
  int i, k = OrdersTotal ();
  if(ot<0 || ot>1) ot=-1;
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        if(ot==-1) {
          if (OrderType()==0 || OrderType()==1) return (true);
        } else {
          if(ot==OrderType()) return (true);
        }
      }
    }
  }
  return (false);
}
//+------------------------------------------------------------------+
bool BuyPos_stepPoint(double _lot, int _sl=0, int _tp=0, string _comment=NULL) {
  double sl=0,tp=0;
  RefreshRates();
  if(_sl>0) sl=Ask-(double)_sl*Point;
  if(_tp>0) tp=Ask+(double)_tp*Point;
  if (!OrderSend(Symb, OP_BUY, NormalizeDouble(_lot, 2), NormalizeDouble(Ask,Digits), Slippage, NormalizeDouble(sl,Digits), NormalizeDouble(tp,Digits), _comment, MagicNumber)) {
    Print("  OP_BUY!");
    return (false);
  }  
  return (true);
}
bool SellPos_stepPoint(double _lot, int _sl=0, int _tp=0, string _comment=NULL) {
  double sl=0,tp=0;
  RefreshRates();
  if(_sl>0) sl=Bid+(double)_sl*Point;
  if(_tp>0) tp=Bid-(double)_tp*Point;
  if (!OrderSend(Symb, OP_SELL, NormalizeDouble(_lot, 2), NormalizeDouble(Bid,Digits), Slippage, NormalizeDouble(sl,Digits), NormalizeDouble(tp,Digits), _comment, MagicNumber)) {
    Print("  OP_SELL!");
    return (false); 
  }  
  return (true);
}
//+------------------------------------------------------------------+